<?php
/*
Plugin Name: History cleanup
Version: 2.1.b
Description: A background process which cleans your history table on regular basis
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=392
Author: VDigital
Author URI: http://piwigo.org/
*/
if ( !function_exists( 'history_cleanup' ) ) {
	if (!defined('IN_ADMIN') or !IN_ADMIN or (defined('DB_ENGINE') and DB_ENGINE == 'SQLite')) return false;
    add_event_handler('loc_begin_page_tail', 'history_cleanup' );
	function history_cleanup()
	{
		global $conf;
		$w = (isset($conf['history_cleanup'])) ? $conf['history_cleanup']
		    : array( 'each' => 30, 'remove' => 90 ); # DAYs 
		$latest = strtotime('-' . $w['each'] . ' days');
		$limit = date ('Y-m-d',strtotime('-' . $w['remove'] . ' days'));
		$previous = pwg_get_session_var('history_check', $latest);
		if ( $previous <= $latest ) {
			$q = '
			DELETE FROM  ' . HISTORY_TABLE . ' 
			 WHERE date < ' . $limit . '
			  AND summarized = "true";';
			$r = pwg_query($q);  
			if($r)
			{
				if (!defined('DB_ENGINE') ) define('DB_ENGINE', 'MySQL');
				switch (DB_ENGINE) {
					case 'PostgreSQL':
						$q = 'VACUUM FULL '.HISTORY_TABLE.';';
						break;
					case 'MySQL':
						$q = 'OPTIMIZE TABLE '.HISTORY_TABLE.';';
						break;
					default:
					   $q = 'VACUUM;';
				}
				$r=pwg_query($q);
			}
			pwg_set_session_var('history_check', strtotime("now"));
			return $r;
		}
		return false;
	}
}
?>